Crypto++

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions
DL_SimpleKeyAgreementDomainBase< T > Class Template Reference

_ More...

`#include <pubkey.h>`

Inheritance diagram for DL_SimpleKeyAgreementDomainBase< T >:

List of all members.

## Public Types

typedef T | Element

## Public Member Functions

CryptoParameters & | AccessCryptoParameters ()
unsigned int | AgreedValueLength () const
| return length of agreed value produced
unsigned int | PrivateKeyLength () const
| return length of private keys in this domain
unsigned int | PublicKeyLength () const
| return length of public keys in this domain
void | GeneratePrivateKey (RandomNumberGenerator &rng, byte *privateKey) const
| generate private key
void | GeneratePublicKey (RandomNumberGenerator &rng, const byte *privateKey, byte *publicKey) const
| generate public key
bool | Agree (byte *agreedValue, const byte *privateKey, const byte *otherPublicKey, bool validateOtherPublicKey=true) const
| derive agreed value from your private key and couterparty's public key, return false in case of failure
const Element & | GetGenerator () const
virtual void | GenerateKeyPair (RandomNumberGenerator &rng, byte *privateKey, byte *publicKey) const
| generate private/public key pair
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual const CryptoParameters & | GetCryptoParameters () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Protected Member Functions

virtual const DL_KeyAgreementAlgorithm < Element > & | GetKeyAgreementAlgorithm () const =0
virtual DL_GroupParameters < Element > & | AccessAbstractGroupParameters ()=0
const DL_GroupParameters < Element > & | GetAbstractGroupParameters () const

## Detailed Description

### template<class T>
class DL_SimpleKeyAgreementDomainBase< T >

_

Definition at line 1376 of file pubkey.h.

## Member Function Documentation

template<class T>

void DL_SimpleKeyAgreementDomainBase< T >::GeneratePrivateKey | ( | RandomNumberGenerator & | rng,
|  | byte * | privateKey
| ) |  | const`[inline, virtual]`

generate private key

Precondition:
  size of privateKey == PrivateKeyLength()

Implements SimpleKeyAgreementDomain.

Definition at line 1386 of file pubkey.h.

template<class T>

void DL_SimpleKeyAgreementDomainBase< T >::GeneratePublicKey | ( | RandomNumberGenerator & | rng,
|  | const byte * | privateKey,
|  | byte * | publicKey
| ) |  | const`[inline, virtual]`

generate public key

Precondition:
  size of publicKey == PublicKeyLength()

Implements SimpleKeyAgreementDomain.

Reimplemented in DH_Domain< GROUP_PARAMETERS, COFACTOR_OPTION >.

Definition at line 1392 of file pubkey.h.

template<class T>

bool DL_SimpleKeyAgreementDomainBase< T >::Agree | ( | byte * | agreedValue,
|  | const byte * | privateKey,
|  | const byte * | otherPublicKey,
|  | bool | validateOtherPublicKey = `true`
| ) |  | const`[inline, virtual]`

derive agreed value from your private key and couterparty's public key, return false in case of failure

Note:
  If you have previously validated the public key, use validateOtherPublicKey=false to save time.

Precondition:
  size of agreedValue == AgreedValueLength()
  length of privateKey == PrivateKeyLength()
  length of otherPublicKey == PublicKeyLength()

Implements SimpleKeyAgreementDomain.

Definition at line 1400 of file pubkey.h.

virtual void SimpleKeyAgreementDomain::GenerateKeyPair | ( | RandomNumberGenerator & | rng,
|  | byte * | privateKey,
|  | byte * | publicKey
| ) |  | const`[virtual, inherited]`

generate private/public key pair

Note:
  equivalent to calling GeneratePrivateKey() and then GeneratePublicKey()

The documentation for this class was generated from the following file:

- pubkey.h